/*************************************************  Device Functions Header  **************************************************

	Red Rapids
	797 North Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Rev History: 2-20-2014:		Inital release.

	Copyright 2014, Red Rapids, Inc.

*************************************************  Device Functions Header  **************************************************/

#ifndef _DEVICE_FUNCTIONS_H_
#define _DEVICE_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Structure to store configuration register settings for the LTC1661 DAC chip.
typedef struct
{
	unsigned long Payload[8][2];
} s_LTC1661;

// Structure to reference all of the device configuration settings for a Model 150.
typedef struct
{
	unsigned long Frequency;
	unsigned long FreqDiv2;
	unsigned long Attenuator;
	unsigned long RefClkOut;
	unsigned long DirectRF;
	s_LTC1661 TrimDACI;
	s_LTC1661 TrimDACQ;
} s_M150Devices;

// Prototypes for each of the device functions.
unsigned long DirectRFEnable(s_Adapter *p_HW, unsigned long Enable);
unsigned long FreqDiv2Enable(s_Adapter *p_HW, unsigned long Enable);
unsigned long LoadAttenuator(s_Adapter *p_HW, unsigned long ChipSelect, unsigned long Data);
unsigned long LoadFrequency(s_Adapter *p_HW, unsigned long ChipSelect, unsigned long Data);
unsigned long LTC1661Write(s_Adapter *p_HW, unsigned long ChipSelect, unsigned long Address, unsigned long Data);
unsigned long RefClkOutEnable(s_Adapter *p_HW, unsigned long Enable);

#ifdef __cplusplus
}
#endif

#endif
